function [paraest,stderror,W_out,V,it,Chi_sta,Pvalue]=gmm_est(c,Y,X,Z,number,K)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Main GMM Code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nlag=round(size(Y,1)^(1/3));
W=zeros(K,K,2);
W(:,:,1)=permute(eye(K),[1 2 3]);
%[c(:,1),fv(:,1)]=fminsearch(@(para)calc_moment(para,1,choice,X_all,Z,W(:,:,1)),c,[]);

options  =  optimset('Algorithm','active-set','TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',10000,'Display','iter-detailed','Diagnostics','on'); 
[c(:,1),fv(:,1)] = fminunc(@(para)calc_moment(para,1,Y,X,Z,W(:,:,1)),c,options);


for i=2:number
mom=calc_moment(c(:,i-1),2,Y,X,Z,W(:,:,i-1));
W(:,:,i)=gmmweightmatrix(mom,nlag);
%[c(:,i),fv(:,i)]=fminsearch(@(para)calc_moment(para,1,choice,X_all,Z,W(:,:,i)),c(:,i-1),[]);

options  =  optimset('Algorithm','active-set','TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',10000,'Display','iter-detailed','Diagnostics','on'); 
[c(:,i),fv(:,i)] = fminunc(@(para)calc_moment(para,1,Y,X,Z,W(:,:,i)),c(:,i-1),options);

if abs(fv(:,i)-fv(:,i-1))/abs(fv(:,i-1))<1e-4 || fv(i)<=1e-15
  break
end
end 
it=i;
if it==number
    error('Number of iteration exceeds defined maximium number')
else 
    paraest=c(:,it);
    f0=calc_moment(paraest,3,Y,X,Z,W(:,:,it));
    for j=1:size(c,1)
        a=zeros(size(c,1),1);
        eps=max(paraest(j)*1e-4,1e-5);
        a(j)=eps;
        M(:,j)=(calc_moment(paraest+a,3,Y,X,Z,W(:,:,it))-f0)/eps;
    end
end
W_out = W(:,:,it);
V=pinv(M'*W(:,:,it)*M)/size(Y,1);
stderror=sqrt(diag(V));
t_sta=paraest./(stderror);
Chi_sta=size(Y,1)*fv(it);
Pvalue=1-chi2cdf(Chi_sta,K-length(c));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Weight matrix using Newey and West
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function W=gmmweightmatrix(mom,nlag)
q=size(mom,2);T=size(mom,1);
a2=zeros(q,q);a3=zeros(q,q);
for j=1:nlag
    a1=zeros(q,q);
    for i=1:(T-j)
       a1=mom(i+j,:)'*mom(i,:)+a1;
    end
    S(:,:,j)=T/(T-q)*1/T*a1;
    a2=(1-j/(nlag+1))*S(:,:,j)+a2;
    a3=(1-j/(nlag+1))*S(:,:,j)'+a3;
end
b1=zeros(q,q);
for i=1:T
    b1=mom(i,:)'*mom(i,:)+b1;
end
if nlag==0
    newS=b1*T/(T-q)*1/T;
else 
    newS=a2+a3+b1*T/(T-q)*1/T;
end
W=pinv(newS);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

