data {
	int<lower=0> N; // Obs
	int<lower=0> K; // Vars
	matrix[N,K] X;
	matrix[N,K] Z; // Exogenous vars
	matrix[K,K] W; // Weighting matrix
	
	vector[N] Y; // Dependent var
}

parameters {
	vector<lower=-100,upper=100>[K] beta; 
} 

model {
	vector[N] eta;
	matrix[N,K] m_t;
	vector[K] m;

	// Moment condition
	eta <- Y - X*beta;
    m_t <- rep_matrix(eta,K) .* Z;
    
    for (k in 1:K) m[k] <- mean(m_t[:,k]);
    
    // Increment pseudo log-likelihood
	increment_log_prob(- 0.5 * m' * W * m);
}

